﻿namespace ProjectSeaplane.CollectionGenericObjects;

public class ListGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    private readonly List<T?> _collection;

    private int _maxCount;

    public int Count => _collection.Count;

    public int SetMaxCount { set { if (value > 0) { _maxCount = value; } } }

    public ListGenericObjects()
    {
        _collection = new();
    }

    public T? Get(int position)
    {
        if (position >= Count || position < 0) return null;
        return _collection[position];
    }

    public int Insert(T obj)
    {
        if (Count == _maxCount) return -1;
        _collection.Add(obj);
        return Count;
    }
    public int Insert(T obj, int position)
    {
        if (Count == _maxCount) return -1;
        if (position >= Count || position < 0) return -1;
        _collection.Insert(position, obj);
        return position;
    }
    public T Remove(int position)
    {
        if (position >= Count || position < 0) return null;
        T obj = _collection[position];
        _collection.RemoveAt(position);
        return obj;
    }
}
